///////////////////////////////////////////
//
// file:  client.cpp
//
// Copyright 1998 Johnny Be Good! Software
//
//                John R. Ashmun
//                jbg@kagi.com
//
///////////////////////////////////////////

#include "client.h"

int main( )
{	
   clientApplication* Application = new clientApplication( );

   Application->PostMessage( B_QUIT_REQUESTED );

   Application->Run( );

   delete Application;

   return 0;
}


clientApplication::clientApplication( )
   : BApplication( "application/x-vnd.jbg-BMCL" )
{
}


void clientApplication::ReadyToRun( )
{
   const char*      protocol_dir_name = "BMORBDemo";
   const char*      factorial_transaction_name = "DemoFactorial";
   int              i = 0;
   int32            transaction_ID = 0;
   double           result = 0;
   double           time1 = 0;
   double           time2 = 0;
   status_t         status = B_OK;
   BMessage*        factorial_request = new BMessage;
   BMessage         reply;
   BMORB_Messenger* server = 0;

   // get access to the demo factorial service.
   server = OpenService( protocol_dir_name,
                         factorial_transaction_name,
                         &transaction_ID );
   if( !server )
   {
      printf( "Can't access service\n" );
   }
   else if( !server->IsValid( ) )
   {
      printf( "Can't access service\n" );
      delete server;
   }
   else
   {
      time1 = system_time( );

      factorial_request->what = transaction_ID;

      for( i = 0; i < 100; i++ )
      {
         factorial_request->MakeEmpty( );

         factorial_request->AddInt32( "FactorialArg", 100 );

         status = server->SendMessage( factorial_request, &reply );

         if( reply.FindDouble( "Result", &result ) != B_OK )
         {
            printf( "Got bad result\n" );
            printf( "SendMessage returned %lx\n", status );
            reply.PrintToStream( );
            break;
         }

      }
      delete factorial_request;

      time2 = system_time( );
      printf( "\nGot result == %g, %d times.\n\n", result, i );
      printf( "     Ended   at:  %19.13g\n", time2 / 1000000.0 );
      printf( "     Started at:  %19.13g\n", time1 / 1000000.0);
      printf( "                  -------------------\n" );
      printf( "Seconds elapsed:  %19.13g\n", (time2 - time1) / 1000000.0 );

      delete server;
   }
}
