///////////////////////////////////////////
//
// file:  server.cpp
//
// Copyright 1998 Johnny Be Good! Software
//
//                John R. Ashmun
//                jbg@kagi.com
//
///////////////////////////////////////////

#include <stdio.h>
#include "server.h"

server_app::server_app( )
   : BApplication( "application/x-vnd.jbg-BMSV" )
{
}


double factorial( double n );

double factorial( double n )
{
  if( n <= 1 )
     return 1;
  else
     return n * factorial( n - 1 );
}


#define ADDEMUP 'ADD_'
#define FACTIT  'FACT'
#define RESULT  'RSLT'
#define SUM     'SUM_'

void server_app::MessageReceived( BMessage* message )
{
   if( message->what == ADDEMUP )
   {
      long sum = message->FindInt32( "Addend1" )
                 + message->FindInt32( "Addend2" );

      BMessage* reply = new BMessage( SUM );

      reply->AddInt32( "Sum", sum );

      message->SendReply( reply );

      delete reply;
   }
   else if( message->what == FACTIT )
   {
      double arg = (double)(message->FindInt32( "FactorialArg" ));
//printf( "server:  Got factorial arg == %g\n", arg );
      BMessage* reply = new BMessage( RESULT );

      reply->AddDouble( "Result", factorial( arg ) );
//printf( "server:  Sending reply with factorial now.\n" );
      message->SendReply( reply );

      delete reply;
   }
   else
      BApplication::MessageReceived( message );
}

int main( )
{
   server_app* Application = new server_app( );

   Application->Run( );

   delete Application;

   return 0;
}
